#include <stdio.h>
#include <stdlib.h>

typedef struct
  {
    int vaha;
    unsigned int hodnota;
  } MINCA;

int zotried (const void *a, const void *b)
{
  int a1, b1;
  a1 = ((MINCA *) a)->vaha;
  b1 = ((MINCA *) b)->vaha;
  if (a1 < b1)
    return (-1);
  if (a1 == b1)
    return (0);
  return (1);    
}

int main (void)
{
  int mozne[500], vaha_prasa=0, vaha, aktualna, pocet_druhov, pripad;
  unsigned int hodnota[500], pocet_pripadov=0, minimum;
  MINCA minca[500];
  int vaha1, vaha2, i, mozne_celkovo=0;
  
  scanf ("%d", &pocet_pripadov);

  /*for (i=0; i<500; ++i)
    hodnota[i] = 0;*/
  
  for (pripad=0; pripad<pocet_pripadov; ++pripad)
    {
      for (i=0; i<500; ++i)
        hodnota[i] = 0;  
    
      scanf ("%d", &vaha1);
      scanf ("%d", &vaha2);
      vaha_prasa = vaha2 - vaha1;
      scanf ("%d", &pocet_druhov);
      
      for (i=0; i<pocet_druhov; ++i)
        scanf ("%u %d", &minca[i].hodnota, &minca[i].vaha);
         
      qsort (minca, pocet_druhov, sizeof (MINCA), zotried);
      
      for (i=0; i<pocet_druhov; ++i)   
        {
          vaha = 0;
          aktualna = i;        
          do {
               while ((vaha+minca[aktualna].vaha) <= vaha_prasa)
                 {
                   vaha += minca[aktualna].vaha;
                   hodnota[i] += minca[aktualna].hodnota;
                   /*printf ("hodnota: %d\n", hodnota[i]);*/
                 }  
               aktualna --;
             } while (aktualna >= 0);
          if (vaha != vaha_prasa) 
            mozne[i] = 0; 
           else 
            mozne[i] = 1;
          /* printf ("%d ? %d ", vaha, vaha_prasa);  */
        }   
      
      mozne_celkovo = 0;
      for (i=0; i<pocet_druhov; ++i)
        if (mozne[i]) mozne_celkovo = 1;
        
      if (mozne_celkovo)
        {
          for (i=0; i<pocet_druhov; ++i)
            if (mozne[i]) minimum = hodnota[i];
          
          for (i=0; i<pocet_druhov; ++i) 
            if ((minimum > hodnota[i]) && mozne[i])
              minimum = hodnota[i];
                   
          printf ("The minimum amount of money in the piggy-bank is %d.\n", minimum);          
        }  
       else 
        printf ("This is impossible.\n");
        
    }
  
  return (0);
}

